BooleanQuery (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.BooleanQuery class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class BooleanQuery

    java.lang.Object
      org.apache.lucene.search.Query
          org.apache.lucene.search.BooleanQuery

All Implemented Interfaces:
  Serializable, Cloneable, Iterable<BooleanClause>

    public class BooleanQuery

extends Query
implements Iterable<BooleanClause>

A Query that matches documents matching boolean combinations of other queries, e.g. `TermQuery`s, `PhraseQuery`s or other BooleanQuerys.

See Also:
  Serialized Form

Nested Class Summary
`protected class` | `BooleanQuery.BooleanWeight` Expert: the Weight for BooleanQuery, used to normalize, score and explain these queries.
`static class` | `BooleanQuery.TooManyClauses` Thrown when an attempt is made to add more than `getMaxClauseCount()` clauses.

Field Summary
`protected int` | `minNrShouldMatch`

Constructor Summary
`BooleanQuery()` Constructs an empty boolean query.
`BooleanQuery(boolean disableCoord)` Constructs an empty boolean query.

Method Summary
`void` | `add(BooleanClause clause)` Adds a clause to a boolean query.
`void` | `add(Query query, BooleanClause.Occur occur)` Adds a clause to a boolean query.
`List<BooleanClause>` | `clauses()` Returns the list of clauses in this query.
`Object` | `clone()` Returns a clone of this query.
`Weight` | `createWeight(Searcher searcher)` Expert: Constructs an appropriate Weight implementation for this query.
`boolean` | `equals(Object o)` Returns true iff `o` is equal to this.
`void` | `extractTerms(Set<Term> terms)` Expert: adds all terms occurring in this query to the terms set.
`BooleanClause[]` | `getClauses()` Returns the set of clauses in this query.
`static int` | `getMaxClauseCount()` Return the maximum number of clauses permitted, 1024 by default.
`int` | `getMinimumNumberShouldMatch()` Gets the minimum number of the optional BooleanClauses which must be satisfied.
`int` | `hashCode()` Returns a hash code value for this object.
`boolean` | `isCoordDisabled()` Returns true iff `Similarity.coord(int,int)` is disabled in scoring for this query instance.
`Iterator<BooleanClause>` | `iterator()` Returns an iterator on the clauses in this query.
`Query` | `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`static void` | `setMaxClauseCount(int maxClauseCount)` Set the maximum number of clauses permitted per BooleanQuery.
`void` | `setMinimumNumberShouldMatch(int min)` Specifies a minimum number of the optional BooleanClauses which must be satisfied.
`String` | `toString(String field)` Prints a user-readable version of this query.

Methods inherited from class org.apache.lucene.search.Query
`combine, getBoost, getSimilarity, mergeBooleanQueries, setBoost, toString, weight`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### minNrShouldMatch

    protected int minNrShouldMatch

Constructor Detail

### BooleanQuery

    public BooleanQuery()

  Constructs an empty boolean query.

### BooleanQuery

    public BooleanQuery(boolean disableCoord)

  Constructs an empty boolean query. `Similarity.coord(int,int)` may be disabled in scoring, as appropriate. For example, this score factor does not make sense for most automatically generated queries, like `WildcardQuery` and `FuzzyQuery`.

  Parameters:
    `disableCoord` - disables `Similarity.coord(int,int)` in scoring.

Method Detail

### getMaxClauseCount

    public static int getMaxClauseCount()

  Return the maximum number of clauses permitted, 1024 by default. Attempts to add more than the permitted number of clauses cause `BooleanQuery.TooManyClauses` to be thrown.

  See Also:
    `setMaxClauseCount(int)`

### setMaxClauseCount

    public static void setMaxClauseCount(int maxClauseCount)

  Set the maximum number of clauses permitted per BooleanQuery. Default value is 1024.

### isCoordDisabled

    public boolean isCoordDisabled()

  Returns true iff `Similarity.coord(int,int)` is disabled in scoring for this query instance.

  See Also:
    `BooleanQuery(boolean)`

### setMinimumNumberShouldMatch

    public void setMinimumNumberShouldMatch(int min)

  Specifies a minimum number of the optional BooleanClauses which must be satisfied.

  By default no optional clauses are necessary for a match (unless there are no required clauses). If this method is used, then the specified number of clauses is required.

  Use of this method is totally independent of specifying that any specific clauses are required (or prohibited). This number will only be compared against the number of matching optional clauses.

  Parameters:
    `min` - the number of optional clauses that must match

### getMinimumNumberShouldMatch

    public int getMinimumNumberShouldMatch()

  Gets the minimum number of the optional BooleanClauses which must be satisfied.

### add

    public void add(Query query,
                    BooleanClause.Occur occur)

  Adds a clause to a boolean query.

  Throws:
    `BooleanQuery.TooManyClauses` - if the new number of clauses exceeds the maximum clause number
  See Also:
    `getMaxClauseCount()`

### add

    public void add(BooleanClause clause)

  Adds a clause to a boolean query.

  Throws:
    `BooleanQuery.TooManyClauses` - if the new number of clauses exceeds the maximum clause number
  See Also:
    `getMaxClauseCount()`

### getClauses

    public BooleanClause[] getClauses()

  Returns the set of clauses in this query.

### clauses

    public List<BooleanClause> clauses()

  Returns the list of clauses in this query.

### iterator

    public final Iterator<BooleanClause> iterator()

  Returns an iterator on the clauses in this query. It implements the `Iterable` interface to make it possible to do:

      for (BooleanClause clause : booleanQuery) {}

  Specified by:
    `iterator` in interface `Iterable<BooleanClause>`

### createWeight

    public Weight createWeight(Searcher searcher)
                        throws IOException

  Description copied from class: `Query`
  Expert: Constructs an appropriate Weight implementation for this query.

  Only implemented by primitive queries, which re-write to themselves.

  Overrides:
    `createWeight` in class `Query`
  Throws:
    `IOException`

### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

  Description copied from class: `Query`
  Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

  Overrides:
    `rewrite` in class `Query`
  Throws:
    `IOException`

### extractTerms

    public void extractTerms(Set<Term> terms)

  Description copied from class: `Query`
  Expert: adds all terms occurring in this query to the terms set. Only works if this query is in its `rewritten` form.

  Overrides:
    `extractTerms` in class `Query`

### clone

    public Object clone()

  Description copied from class: `Query`
  Returns a clone of this query.

  Overrides:
    `clone` in class `Query`

### toString

    public String toString(String field)

  Prints a user-readable version of this query.

  Specified by:
    `toString` in class `Query`

### equals

    public boolean equals(Object o)

  Returns true iff `o` is equal to this.

  Overrides:
    `equals` in class `Query`

### hashCode

    public int hashCode()

  Returns a hash code value for this object.

  Overrides:
    `hashCode` in class `Query`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD